//----------------------------------------------------------------------
//MODEULE: ni_15.c
//COMMON DESCRIPTION:
//  This module provide support bus NI-15 (NedoInterface-15)
//----------------------------------------------------------------------
#ifdef NI_15_ENABLED
//----------------------------------------------------------------------
// Reset control signal
#define NI_15_RESCTRL() output(NI_15_CPORT, (input(NI_15_CPORT) | ((1<<NI_15_CS) \
					      | (1<<NI_15M_IO) \
					      | (1<<NI_15_RD) \
					      | (1<<NI_15_WR) \
					       ) \
			 )                   & ~(1<<NI_15ALE) \
	   );_NOP();_NOP(); \
     /* Set CDDR */ \
     output(NI_15_CDDR,  (input(NI_15_CDDR)  | ((1<<NI_15_CS)  \
					      | (1<<NI_15M_IO) \
					      | (1<<NI_15_RD)  \
					      | (1<<NI_15_WR)  \
					      | (1<<NI_15ALE)  \
					       ) \
			 ) \
	   );_NOP();_NOP();
// Data bus to input
#define NI_15_RESDATA() output(NI_15_DDDR, 0x00);_NOP();_NOP();
//----------------------------------------------------------------------
  // Init NI_15
  void ni_15_init()
    {// Init Control signal
     // Set CPORT
     NI_15_RESCTRL();
     // Data bus setting for input
     NI_15_RESDATA();
    }
  //--------------------------------------------------------------------
  // Read from memory
  unsigned char ni_15_rdmem(unsigned int adr)
    {unsigned char rb;
     // Set M_IO = 1 _CS = 1 (memory)
     output(NI_15_CPORT, input(NI_15_CPORT) | (1<<NI_15M_IO) | (1<<NI_15_CS) );_NOP();_NOP();
     // Output adress to DATA BUS
     output(NI_15_DPORT, adr);_NOP();_NOP();
     output(NI_15_DDDR, 0xFF);_NOP();_NOP();
     // Clacaem ALE
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15ALE)  );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) & (~(1<<NI_15ALE)) );_NOP();_NOP();
     // Set Data Bus for input
     output(NI_15_DDDR, 0x00);_NOP();_NOP();
     // Set _RD=0
     output(NI_15_CPORT, input(NI_15_CPORT) | (~(1<<NI_15_RD)) );_NOP();_NOP();
     // Read data from bus
     rb = input(NI_15_DPORT);
     // Set _RD=1
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15_RD)  );_NOP();_NOP();
     //
     return(rb);
    }
  //--------------------------------------------------------------------
  // Read from IO-port
  unsigned char ni_15_rdio(unsigned int adr)
    {unsigned char rb;
     // Set M_IO = 0 _CS = 0 (ioport)
     output(NI_15_CPORT, input(NI_15_CPORT) | (~((1<<NI_15M_IO) | (1<<NI_15_CS)) ));_NOP();_NOP();
     // Output adress to DATA BUS
     output(NI_15_DPORT, adr);_NOP();_NOP();
     output(NI_15_DDDR, 0xFF);_NOP();_NOP();
     // Clacaem ALE
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15ALE)  );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) & (~(1<<NI_15ALE)) );_NOP();_NOP();
     // Set Data Bus for input
     output(NI_15_DDDR, 0x00);_NOP();_NOP();
     // Set _RD=0
     output(NI_15_CPORT, input(NI_15_CPORT) | (~(1<<NI_15_RD)) );_NOP();_NOP();
     // Read data from bus
     rb = input(NI_15_DPORT);
     // Set _RD=1 _CS=1
     output(NI_15_CPORT, input(NI_15_CPORT) |  (1<<NI_15_RD) | (1<<NI_15_CS) );_NOP();_NOP();
     //
     return(rb);
    }
  //--------------------------------------------------------------------
  // Write to memory
  void ni_15_wrmem(unsigned int adr, unsigned char byte)
    {// Set M_IO = 1 _CS = 1 (memory)
     output(NI_15_CPORT, input(NI_15_CPORT) | (1<<NI_15M_IO) | (1<<NI_15_CS) );_NOP();_NOP();
     // Output adress to DATA BUS
     output(NI_15_DPORT, adr);_NOP();_NOP();
     output(NI_15_DDDR, 0xFF);_NOP();_NOP();
     // Clacaem ALE
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15ALE)  );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) & (~(1<<NI_15ALE)) );_NOP();_NOP();
     // Set data to DATA BUS
     output(NI_15_DPORT, byte);_NOP();_NOP();
     // Set _WR=0
     output(NI_15_CPORT, input(NI_15_CPORT) | (~(1<<NI_15_WR)) );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15_WR)  );_NOP();_NOP();
     // Set Data Bus for input
     output(NI_15_DDDR, 0x00);_NOP();_NOP();
     //
    }
  //--------------------------------------------------------------------
  // Write to IO-port
  void ni_15_wrio(unsigned int adr, unsigned char byte)
    {// Set M_IO = 0 _CS = 0 (ioport)
     output(NI_15_CPORT, input(NI_15_CPORT) | (~((1<<NI_15M_IO) | (1<<NI_15_CS)) ));_NOP();_NOP();
     // Output adress to DATA BUS
     output(NI_15_DPORT, adr);_NOP();_NOP();
     output(NI_15_DDDR, 0xFF);_NOP();_NOP();
     // Clacaem ALE
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15ALE)  );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) & (~(1<<NI_15ALE)) );_NOP();_NOP();
     // Set data to DATA BUS
     output(NI_15_DPORT, byte);_NOP();_NOP();
     // Set _WR=0
     output(NI_15_CPORT, input(NI_15_CPORT) | (~(1<<NI_15_WR)) );_NOP();_NOP();
     output(NI_15_CPORT, input(NI_15_CPORT) |   (1<<NI_15_WR)  );_NOP();_NOP();
     // Set Data Bus for input
     output(NI_15_DDDR, 0x00);_NOP();_NOP();
     // Set _CS=1
     output(NI_15_CPORT, input(NI_15_CPORT) | (1<<NI_15_CS) );_NOP();_NOP();
    }
  //--------------------------------------------------------------------
#endif
//----------------------------------------------------------------------
