//----------------------------------------------------------------------
//MODEULE: pwm.c
//COMMON DESCRIPTION:
//  This module provide support PWM 
//----------------------------------------------------------------------
//
#ifdef PWM_ENABLED
  // PWM init procedure
  void pwm_init()
    {pwm_set_A(0);
     pwm_set_B(0);
     output(TCCR1B,0x00);_NOP();_NOP();
     output(TCCR1A,0x00);_NOP();_NOP();     
    }
  // Start PWM
  void pwm_start()
    {output(TCCR1A,(PWM_CHAN_A << COM1A0) | (PWM_CHAN_B << COM1B0) | (PWM_SCALE << PWM10));_NOP();_NOP();     
     output(TCNT1H,0);_NOP();_NOP();
     output(TCNT1L,0);_NOP();_NOP();      
     output(TCCR1B,PWM_TIME_CONST);_NOP();_NOP();
     output(PWM_DDR,input(PWM_DDR) | (1<<PWM_PIN_A) | (1<<PWM_PIN_B));_NOP();_NOP();
    }
  // Stop PWM
  void pwm_stop()
    {pwm_set_A(0);
     pwm_set_B(0);
     output(TCCR1B,0x00);_NOP();_NOP();
     output(PWM_DDR,input(PWM_DDR) & ~((1<<PWM_PIN_A) | (1<<PWM_PIN_B)));_NOP();_NOP();
    }
  // Set wide of pulse for channel A
  void pwm_set_A(unsigned int w)
    {output(OCR1AH,(w >> 0x08));_NOP();_NOP();
     output(OCR1AL,(w & 0xFF));_NOP();_NOP();
    }
  // Set wide of pulse for channel B
  void pwm_set_B(unsigned int w)
    {output(OCR1BH,(w >> 0x08));_NOP();_NOP();
     output(OCR1BL,(w & 0xFF));_NOP();_NOP();
    }
//----------------------------------------------------------------------
#endif
