//----------------------------------------------------------------------
//MODEULE: timer0.c
//COMMON DESCRIPTION:
//  This module provide interrupt and timer0 handling and controls. 
//----------------------------------------------------------------------
#include "avr/signal.h"
//
#ifdef TIMER0_ENABLED
void timer0_init()
  {// If enabled TIMER0 overflow interrupt 
   output(TCCR0,TIMER0_TCCR); // Set clock of TIMER0 independent     
   output(TIMSK,input(TIMSK) | (1 << TOIE0)); // Enable Timer0 overflow interrupt
   output(TIFR, input(TIFR)  | (1 << TOIE0)); // Reset Timer0 overflow interrupt flag   
  }
#endif
//----------------------------------------------------------------------
#ifdef TIMER0_ENABLED
  unsigned int   TIMER_100ms;
  unsigned int   TIMER_1sec;
  unsigned char  TIMER_1min;
  unsigned char  TIMER_1hour;
  // Timer0 owerflow interrupt handler
 SIGNAL (SIG_OVERFLOW0)
  {// Max frq int   
   #ifdef T_INT_MAX_0
   T_INT_MAX_0();
   #endif
   #ifdef T_INT_MAX_1
   T_INT_MAX_1();
   #endif
   #ifdef T_INT_MAX_2
   T_INT_MAX_2();
   #endif
   #ifdef T_INT_MAX_3
   T_INT_MAX_3();
   #endif
   // 0.1 sec timer
   if(TIMER_100ms){TIMER_100ms--;}
   if(!TIMER_100ms)
     {// 0.1 sec passed
      TIMER_100ms = F_TIMER0/10;// May be ~0.1sec
      #ifdef RT_RUNTASK_100ms
      RT_RUNTASK_100ms();
      #endif      
      #ifdef T_INT_100MS_0
      T_INT_100MS_0();
      #endif
      #ifdef T_INT_100MS_1
      T_INT_100MS_1();
      #endif
      #ifdef T_INT_100MS_2
      T_INT_100MS_2();
      #endif
      #ifdef T_INT_100MS_3
      T_INT_100MS_3();
      #endif
     }
   // 1 sec timer
   if(TIMER_1sec){TIMER_1sec--;}
   if(!TIMER_1sec)
     {// 1 sec passed            
      TIMER_1sec = F_TIMER0;
      #ifdef RT_RUNTASK_1s
      RT_RUNTASK_1s();
      #endif
      #ifdef T_INT_1S_0
      T_INT_1S_0();
      #endif
      #ifdef T_INT_1S_1
      T_INT_1S_1();
      #endif
      #ifdef T_INT_1S_2
      T_INT_1S_2();
      #endif
      #ifdef T_INT_1S_3
      T_INT_1S_3();
      #endif
      // 1 min timer
      if(TIMER_1min){TIMER_1min--;}
      if(!TIMER_1min)
        {// 1 min passed
         TIMER_1min=60;
	 #ifdef RT_RUNTASK_1m
         RT_RUNTASK_1m();
         #endif
         #ifdef T_INT_1M_0
         T_INT_1M_0();
         #endif
	 #ifdef T_INT_1M_1
         T_INT_1M_1();
         #endif
	 #ifdef T_INT_1M_2
         T_INT_1M_2();
         #endif
	 #ifdef T_INT_1M_3
         T_INT_1M_3();
         #endif
	 // 1 hour timer
	 if(TIMER_1hour){TIMER_1hour--;}
         if(!TIMER_1hour)
           {// 1 hour passed
	    TIMER_1hour=60;
	    #ifdef RT_RUNTASK_1h
            RT_RUNTASK_1h();
            #endif
	    #ifdef T_INT_1H_0
            T_INT_1H_0();
            #endif
	    #ifdef T_INT_1H_1
            T_INT_1H_1();
            #endif
	    #ifdef T_INT_1H_2
            T_INT_1H_2();
            #endif
	    #ifdef T_INT_1H_3
            T_INT_1H_3();
            #endif
	  }
        }
     }     
  }
#endif  
//----------------------------------------------------------------------
