//----------------------------------------------------------------------
//MODEULE: res_ni_15.h
//COMMON DESCRIPTION:
//  This module provide support bus NI-15 (NedoInterface-15)
//----------------------------------------------------------------------
// NI-15 description
//  pin  signal   Description
//   1    GND        (power, 0V)
//   2    _CS        (chip select, active 0)
//   3    ALE        (low byte of adress on data-bus, active 1)
//   4    M_IO       (use memory (if M_IO=1), or i/o-porst (if M_IO=0))
//   5    _RD        (reading, active 0)
//   6    _WR        (writing, active 0)
//   7    D0         (Data bus, bit 0)
//   8    D1         (Data bus, bit 1)
//   9    D2         (Data bus, bit 2)
//   10   D3         (Data bus, bit 3)
//   11   D4         (Data bus, bit 4)
//   12   D5         (Data bus, bit 5)
//   13   D6         (Data bus, bit 6)
//   14   D7         (Data bus, bit 7)
//   15   Vcc        (power, +5V)
//----------------------------------------------------------------------
//   Resorce of NI_15_ENABLED:
// NI_15_ENABLED_ENABLED - if it symbol defined then NI_15 will be inited and enabled
//----------------------------------------------------------------------
#define NI_15_ENABLED
//----------------------------------------------------------------------
#ifdef  NI_15_ENABLED
//----------------------------------------------------------------------
// NI-15
//----------------------------------------------------------------------
// Define ports (Defines by user)
//----------------------------------------------------------------------
/* Control signal port (emulate _CS, ALE, M_IO, _RD, _WR) */
#define NI_15_CPORT          PORTA 
#define NI_15_CDDR           DDRA
/* Data port (emulate data-bus) */
#define NI_15_DPORT          PORTC
#define NI_15_DDDR           DDRC
//----------------------------------------------------------------------
// Signal bits
//----------------------------------------------------------------------
#define NI_15_CS             0x00
#define NI_15ALE             0x01
#define NI_15M_IO            0x02
#define NI_15_RD             0x03
#define NI_15_WR             0x04
//----------------------------------------------------------------------
#endif  /* ADC0_ENABLED */
//----------------------------------------------------------------------
